/*
Copyright (C) 2008 Nick Scheibenpflug (Zorchenhimer)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 3
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#include <cstdlib>
#include <iostream>
#include <fstream>
#include <string.h>

using namespace std;

void printHelp(void);
void process(void);
void getInfo(void);
void doPause(void);

fstream source;
fstream product;

char targetTexture[64];// e.g. "abandon/fueldrum1c_mud";
char mapName[64];
char mapNameNew[64];

int main(int argc, char *argv[])
{
	bool done = false;
	if (argc > 1) {
		if (strcmp("-h",argv[1]) == 0 || strcmp(argv[1],"/?") == 0 || strcmp(argv[1], "--help") == 0) {
			printHelp();
			return 0;
		} else if ( argc = 3 ) {
			// skip the input process
			strcpy(mapName, argv[1]);
			strcpy(targetTexture, argv[2]);
			
			strcpy(mapNameNew, mapName);
			strcat(mapNameNew, "_new.map");
			strcat(mapName, ".map");
			
			process();
			done = true;
		}
	}

	if (done == false) {
		// go through the manual input process
		getInfo();
		process();
	}
	
	cout << "Done!";
	doPause();
	return 0;

}

void process() {
	// cout << "in process()" << endl;
    source.open(mapName,ios::in);
    product.open(mapNameNew,ios::out);
    int lineNumber = 0;
    char lineContents[256] = "contents";
    //system("pause");
    int brushNumber = 10;
    int brushes = 0;
    bool end = false;
    while (!source.eof()) { //end != true
          source.getline(lineContents, 256);
          
          if (strstr(lineContents, "{")) {
             brushNumber += 1;
          }
          
          if (strstr(lineContents, targetTexture)) {
             char brushNumberStr[32];
             //itoa(brushNumber, brushNumberStr, 10);
	     sprintf(brushNumberStr,"%d",brushNumber);
             strcat(lineContents, brushNumberStr);
             product << lineContents << endl;
             brushes += 1;
          } else {
             product << lineContents <<endl;
          }
          lineNumber += 1;
          
          if (source.eof())
             end = true;
    }
    product.close();
    source.close();
	cout << "Brushes affected: " << brushes << endl;
}

void getInfo() {
    cout << "Map name: ";
    cin >> mapName;
    strcpy(mapNameNew, mapName);
    strcat(mapNameNew, "_new.map");
    strcat(mapName, ".map");
    
    cout << endl << "] Map name: " << mapName << endl;
    cout << "] Output map: " << mapNameNew << endl << endl;
    
    if(!fopen(mapName,"r")) {
        cout << "Error: file doesnt exist!" << endl;
		doPause();
        return;
    }
    
    cout << "Target texture: ";
    cin >> targetTexture;
	cin.ignore(64, '\n');
    
    cout << "] Target texure: " << targetTexture << endl << endl;
	return;
}

void printHelp() {
	cout << endl;
	cout << "Usage: phongScript.exe [ /? | -h | --help | <mapName> <targetTexture> ]" << endl << endl;
	cout << "   /?, -h, --help" << endl;
	cout << "        Prints this help message and exits." << endl << endl;
	cout << "   <mapName>" << endl;
	cout << "        The map to use without the '.map' extension." << endl << endl;
	cout << "   <targetTexture>" << endl;
	cout << "         The texture that is to be affected.  E.g. 'abandon/fueldrum1c_mud'\n         or 'pball/b_brl1'" << endl;
	return;
}

void doPause() {
	 //char pausekey;
	 cout << "\n\n= Paused =" << endl;
	 //cin.get(pausekey);
	 getchar();
}
